public class RationalC implements Rational {

    private int numerator;
    private int denominator;

    public RationalC(int numerator, int denominator) {
        reduce(numerator, denominator);
    }

    // Are these a good idea???
    public int getNumerator() { return this.numerator; }
    public int getDenominator() { return this.denominator; }

    private int gcd(int m, int n) {
        if (n == 0)
            return m;
        else
            return gcd(n, m % n);
    }

    private void reduce(int a, int b) {
        int g = gcd(a, b);
        this.numerator = a / g;
        this.denominator = b / g;
        if (b < 0) {
            this.numerator = -this.numerator;
            this.denominator = -this.denominator;
        }
    }

    public Rational add(Rational other) {

        int tn = this.getNumerator();
        int td = this.getDenominator();
        int on = other.getNumerator(); // on
        int od = other.getDenominator(); // od

        return new RationalC(tn*od + td*on, td*od);
    }

    public int compareTo(Rational other) {
        Integer a = this.getNumerator() * other.getDenominator();
        Integer b = this.getDenominator() * other.getNumerator();
        return a.compareTo(b);
    }

    public String toString() {
        return this.numerator + "/" + this.denominator;
    }

    public Rational increment() {
      return new RationalC(this.numerator + this.denominator, this.denominator);
    }

    public static void main(String[] args) {

        Rational r1 = new RationalC(4, 6);
        System.out.println("r1=" + r1.toString());
        Rational r2 = r1.increment();
        System.out.println("r1=" + r1.toString());
      }
}
